<template>
  <div class="control-calctext">
     <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || field.textType == 'hidden'"
    >
      <div class="component-input-span" v-if="field.value">
        <div class="content" v-if="isJump">
          <component :is="template(field.value)"></component>
        </div>
        <div class="content" v-else>
          <span 
            :id="id" 
            :name="field.name+'_show'" 
            v-append="setValue(field.value)"></span>
        </div>
      </div>
    </template>
    <!--只读-->
    <template v-else-if="field.textType == 'readonly' || field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED">
      <div class="component-input-span component-o-calctext" v-if="field.value">
        <div class="content" v-if="isJump">
          <component :is="template(field.value)"></component>
        </div>
        <div class="content" v-else>
          <span 
            :id="id" 
            :name="field.name+'_show'" 
            v-append="setValue(field.value)"></span>
        </div>
      </div>
    </template>

    <!-- 可编辑 -->
    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY" >
      <div class="component-input-span component-o-calctext" v-if="field.value">
        <div class="content" v-if="isJump">
          <component :is="template(field.value)"></component>
        </div>
        <div class="content" v-else>
          <span 
            :id="id" 
            :name="field.name+'_show'" 
            v-append="setValue(field.value)"></span>
        </div>
      </div>
    </template>
  </div>
</template>

<script>
// import Constant from "@/Constant.js";
import Constant from "@/Constant.js"
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-calctext",
  props: ["id"],
  computed: {
    field: function() {
      let data = this.$parent.findField(this.id);
      this.jumpToNewpage(data);
      return data;
    }
  },

  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },

  data: function() {
    return {
      Constant,
      isJump:false,
    };
  },

  methods: {
    setValue(value) {
      if(value.indexOf("viewer.html") > -1) {
        let myProfile = this.$store.state.myProfile;
        let loginNo = myProfile?myProfile.loginNo:'';
        sessionStorage.setItem("loginNo", loginNo);
        let path = value.split("?");
        let pathR = path[1];
        let url = "<iframe src=" + '"' + obpmConfig.obpmFilePath + obpmConfig.statiContextPath + "/mobile/iwebapp/pdfjs/viewer.html?contextPath=" + pathR;
        return url
      }else {
        return value;
      }
    },

    //o-action跳转
    calctextJump(params){
      this.$router.push(params)
    },

    template(val) {
      return {
        methods: {
          calctextJump: this.calctextJump,
        },
        template: "<div>"+val+"</div>"
      }
      // return {
      //   template: "<div>"+val+"</div>"
      // }
    },

    jumpToNewpage(data) {
      if(data.value) {
        if(data.value.search("o-action") != -1) {
          this.isJump = true;
        }else {
          this.isJump = false;
        }
      } 
    }
  }
};
</script>